package com.qmion.flutter_navigation_bar;

import android.app.Activity;
import android.content.Context;
import android.os.Build;
import android.view.WindowManager;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** FlutterNavigationBarPlugin */
public class FlutterNavigationBarPlugin implements MethodCallHandler {

  private final Activity activity;
  private final Context context;

  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "flutter_navigation_bar");
    channel.setMethodCallHandler(new FlutterNavigationBarPlugin(registrar.activity(), channel, registrar.context()));
  }

  private FlutterNavigationBarPlugin(Activity activity, MethodChannel channel, Context context){
    this.activity = activity;
    this.context = context;
    channel.setMethodCallHandler(this);
    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
      this.activity.getWindow().setFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS, WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS);
      this.activity.getWindow().setStatusBarColor(0);
    }
    this.activity.getWindow().setFlags(WindowManager.LayoutParams.FLAG_LAYOUT_NO_LIMITS, WindowManager.LayoutParams.FLAG_LAYOUT_NO_LIMITS);
  }

//  boolean hasSoftKeys(WindowManager windowManager){
//    Display d = windowManager.getDefaultDisplay();
//
//    DisplayMetrics realDisplayMetrics = new DisplayMetrics();
//    d.getRealMetrics(realDisplayMetrics);
//
//    int realHeight = realDisplayMetrics.heightPixels;
//    int realWidth = realDisplayMetrics.widthPixels;
//
//    DisplayMetrics displayMetrics = new DisplayMetrics();
//    d.getMetrics(displayMetrics);
//
//    int displayHeight = displayMetrics.heightPixels;
//    int displayWidth = displayMetrics.widthPixels;
//
//    return (realWidth - displayWidth) > 0 || (realHeight - displayHeight) > 0;
//  }
//
//  public static Point getNavigationBarSize(Context context) {
//    Point appUsableSize = getAppUsableScreenSize(context);
//    Point realScreenSize = getRealScreenSize(context);
//    float DP = context.getResources().getDisplayMetrics().density;
//
//    // navigation bar on the side
//    if (appUsableSize.x < realScreenSize.x) {
////      return new Point(Math.round((realScreenSize.x - appUsableSize.x - getStatusBarHeight(context)) / DP), Math.round(appUsableSize.y / DP));
//      return new Point(Math.round(appUsableSize.x / DP), Math.round((realScreenSize.y - appUsableSize.y) / DP));
//    }
//
//    // navigation bar at the bottom
//    if (appUsableSize.y < realScreenSize.y) {
//      return new Point(Math.round(appUsableSize.x / DP), Math.round((realScreenSize.y - appUsableSize.y - getStatusBarHeight(context)) / DP));
//    }
//
//    // navigation bar is not present
//    return new Point();
//  }
//
//  public static Point getAppUsableScreenSize(Context context) {
//    WindowManager windowManager = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
//    Display display = windowManager.getDefaultDisplay();
//    Point size = new Point();
//    display.getSize(size);
//    return size;
//  }
//
//  public static Point getRealScreenSize(Context context) {
//    WindowManager windowManager = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
//    Display display = windowManager.getDefaultDisplay();
//    Point size = new Point();
//
//    if (Build.VERSION.SDK_INT >= 17) {
//      display.getRealSize(size);
//    } else if (Build.VERSION.SDK_INT >= 14) {
//      try {
//        size.x = (Integer) Display.class.getMethod("getRawWidth").invoke(display);
//        size.y = (Integer) Display.class.getMethod("getRawHeight").invoke(display);
//      } catch (IllegalAccessException e) {} catch (InvocationTargetException e) {} catch (NoSuchMethodException e) {}
//    }
//
//    return size;
//  }
//
//  public static int getStatusBarHeight(Context context) {
//    int result = 0;
//    int resourceId = context.getResources().getIdentifier("status_bar_height", "dimen", "android");
//    if (resourceId > 0) {
//      result = context.getResources().getDimensionPixelSize(resourceId);
//    }
//    return result;
//  }
//
//  public static int getStatusBarHeightLandscape(Context context) {
//    int result = 0;
//    int resourceId = context.getResources().getIdentifier("status_bar_height_landscape", "dimen", "android");
//    if (resourceId > 0) {
//      result = context.getResources().getDimensionPixelSize(resourceId);
//    }
//    return result;
//  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    switch (call.method) {
      case "getPlatformVersion":
        result.success("Android " + Build.VERSION.RELEASE);
        break;
      case "setNavigationBarTransparent":
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
          this.activity.getWindow().setFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS, WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS);
//          this.activity.getWindow().setStatusBarColor(0xFF00FF00);
//          this.activity.getWindow().setNavigationBarColor(0xFF00FF00);
          this.activity.getWindow().setStatusBarColor(0);
        }
//
//      this.activity.getWindow().setFlags(WindowManager.LayoutParams.FLAG_LAYOUT_IN_OVERSCAN, WindowManager.LayoutParams.FLAG_LAYOUT_IN_OVERSCAN);
        this.activity.getWindow().setFlags(WindowManager.LayoutParams.FLAG_LAYOUT_NO_LIMITS, WindowManager.LayoutParams.FLAG_LAYOUT_NO_LIMITS);
//      this.activity.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);


//      Toast.makeText(activity, "Hello", Toast.LENGTH_LONG).show();
        result.success("OK");
        break;
      case "getNavigationBarHeight":
        double _navigation_bar_height = 0.0;
//      Resources resources = this.context.getResources();
//      int resourceId = resources.getIdentifier("navigation_bar_height", "dimen", "android");
////      int resourceId = resources.getIdentifier("navigation_bar_height_landscape", "dimen", "android");
//      if (resourceId > 0) {
//        _navigation_bar_height = resources.getDimensionPixelSize(resourceId)+0.0;
////        result.success(resources.getDimensionPixelSize(resourceId)+0.0);
//      } else {
////        result.success(-0.1);
//        _navigation_bar_height = 1.0;
//      }
//      int id = resources.getIdentifier("config_showNavigationBar", "bool", "android");
//      if (id > 0) {
//        if (resources.getBoolean(id))
//          _navigation_bar_height = _navigation_bar_height + 10000.0;
//        else
//          _navigation_bar_height = _navigation_bar_height + 200000.0;
//
//        boolean hasMenuKey = ViewConfiguration.get(this.context).hasPermanentMenuKey();
//        boolean hasBackKey = KeyCharacterMap.deviceHasKey(KeyEvent.KEYCODE_BACK);
////        if (!hasMenuKey && !hasBackKey)
//        if (hasMenuKey)
//          _navigation_bar_height = _navigation_bar_height + 3000000.0;
//        if (hasBackKey)
//          _navigation_bar_height = _navigation_bar_height + 40000000.0;
//
//      } else {    // Check for keys
//        boolean hasMenuKey = ViewConfiguration.get(this.context).hasPermanentMenuKey();
//        boolean hasBackKey = KeyCharacterMap.deviceHasKey(KeyEvent.KEYCODE_BACK);
////        if (!hasMenuKey && !hasBackKey)
////          _navigation_bar_height = _navigation_bar_height + 60000.0;
////        else
////          _navigation_bar_height = _navigation_bar_height + 70000.0;
//        if (hasMenuKey)
//          _navigation_bar_height = _navigation_bar_height + 500000000.0;
//        if (hasBackKey)
//          _navigation_bar_height = _navigation_bar_height + 6000000000.0;
//      }
////      if (checkDeviceHasNavigationBar(this.context))
////        _navigation_bar_height = _navigation_bar_height +   800000000000.0;
//
////      _navigation_bar_height = (getNavigationBarSize(this.context).y+0.0)/1000;
//      _navigation_bar_height = getNavigationBarSize(this.context).x + ((getNavigationBarSize(this.context).y+0.0)/1000);
        result.success(_navigation_bar_height);
        break;
      default:
        result.notImplemented();
        break;
    }
  }
}

